#include <termios.h> //struct termios
#include <unistd.h> //isatty
#include <fcntl.h> //open
#include <stdio.h>

#define NOTATTY 1

int main(int argc, char const *argv[])
{
  //deskriptor pre terminál, z ktorého je program spustený
	int ttyZariadenie = STDIN_FILENO;

  //získanie deskriptora pre druhý terminál
	int fd = open(argv[1], O_WRONLY);
    if(fd == -1){
        perror("open");
        return -1;
    }
	
	struct termios term_old, term_new;
    char buffer[255]; 
    int nacitane;

	// test či deskriptor súboru odkazuje na terminál
	if ( ! isatty(ttyZariadenie) ) {
        return(NOTATTY);
	}
	else {
		if (tcgetattr(ttyZariadenie, &term_old) != 0){
      perror("tcgetattr error");
    }     
    else {
      term_new = term_old;
      //vypnutie echa a nastavenie nekanonického režimu
      term_new.c_lflag &= ~( ICANON | ECHO );
      tcsetattr(ttyZariadenie, TCSANOW, &term_new); 

     	while(1){
     		nacitane = read(ttyZariadenie, &buffer, 255);
        //sledovaie, kedy sa vykoná read()
        printf("read\n");
        //ukončenie načítavania C + d */
     		if (buffer[0] == '\004')          
        	break;
      	else{
          //zapísanie do druhého terminálu
      		write(fd, &buffer, nacitane);
      	}		
     	}
            
      tcsetattr(ttyZariadenie, TCSANOW, &term_old);
      printf("obnovené pôvodné nastavenia\n");
    }
	}

	return 0;
}